Index: /trunk/src/VBox/Additions/common/VBoxGuestLib/VBoxGuestR3Lib.cpp
===================================================================
--- /trunk/src/VBox/Additions/common/VBoxGuestLib/VBoxGuestR3Lib.cpp	(revision 45355)
+++ /trunk/src/VBox/Additions/common/VBoxGuestLib/VBoxGuestR3Lib.cpp	(revision 45356)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2007-2012 Oracle Corporation
+ * Copyright (C) 2007-2013 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -383,7 +383,6 @@
 
 #elif defined(RT_OS_HAIKU)
-	/* The ioctl hook in Haiku does take the len parameter when specified,
-	 * so just use it.
-	 */
+    /* The ioctl hook in Haiku does take the len parameter when specified,
+     * so just use it. */
     int rc = ioctl((int)g_File, iFunction, pvData, cbData);
     if (RT_LIKELY(rc == 0))
Index: /trunk/src/VBox/Additions/common/VBoxService/VBoxServiceVMInfo.cpp
===================================================================
--- /trunk/src/VBox/Additions/common/VBoxService/VBoxServiceVMInfo.cpp	(revision 45355)
+++ /trunk/src/VBox/Additions/common/VBoxService/VBoxServiceVMInfo.cpp	(revision 45356)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2009-2012 Oracle Corporation
+ * Copyright (C) 2009-2013 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -393,5 +393,5 @@
 static dbus_bool_t vboxService_dbus_message_get_args(DBusMessage *message,
                                                      DBusError   *error,
-                                                     int  	      first_arg_type,
+                                                     int first_arg_type,
                                                      ...)
 {
Index: /trunk/src/VBox/Additions/haiku/VBoxTray/VBoxGuestDeskbarView.h
===================================================================
--- /trunk/src/VBox/Additions/haiku/VBoxTray/VBoxGuestDeskbarView.h	(revision 45355)
+++ /trunk/src/VBox/Additions/haiku/VBoxTray/VBoxGuestDeskbarView.h	(revision 45356)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2012 Oracle Corporation
+ * Copyright (C) 2012-2013 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -72,5 +72,5 @@
         virtual ~VBoxGuestDeskbarView();
 
-		static  BArchivable*   Instantiate(BMessage *data);
+        static  BArchivable*   Instantiate(BMessage *data);
         virtual status_t       Archive(BMessage *data, bool deep = true) const;
 
Index: /trunk/src/VBox/Additions/haiku/VBoxVideo/driver/driver.cpp
===================================================================
--- /trunk/src/VBox/Additions/haiku/VBoxVideo/driver/driver.cpp	(revision 45355)
+++ /trunk/src/VBox/Additions/haiku/VBoxVideo/driver/driver.cpp	(revision 45356)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2012 Oracle Corporation
+ * Copyright (C) 2012 Oracle-2013 Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -114,9 +114,9 @@
 struct DeviceInfo
 {
-    uint32          openCount;      		/* Count of how many times device has been opened */
-    uint32          flags;					/* Device flags */
-    area_id         sharedArea;     		/* Area shared between driver and all accelerants */
-    SharedInfo     *sharedInfo;     		/* Pointer to shared info area memory */
-    pci_info        pciInfo;        		/* Copy of pci info for this device */
+    uint32          openCount;              /* Count of how many times device has been opened */
+    uint32          flags;                  /* Device flags */
+    area_id         sharedArea;             /* Area shared between driver and all accelerants */
+    SharedInfo     *sharedInfo;             /* Pointer to shared info area memory */
+    pci_info        pciInfo;                /* Copy of pci info for this device */
     char            name[B_OS_NAME_LENGTH]; /* Name of device */
 };
Index: /trunk/src/VBox/Additions/linux/drm/vboxvideo.h
===================================================================
--- /trunk/src/VBox/Additions/linux/drm/vboxvideo.h	(revision 45355)
+++ /trunk/src/VBox/Additions/linux/drm/vboxvideo.h	(revision 45356)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2011-2012 Oracle Corporation
+ * Copyright (C) 2011-2013 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -68,6 +68,6 @@
     struct vboxvideo_mode_info  mode_info;
 
-    int				    num_crtc;
+    int                 num_crtc;
 };
 
-#endif                /* __DRM_VBOXVIDEO_H__ */
+#endif /* __DRM_VBOXVIDEO_H__ */
Index: /trunk/src/VBox/Additions/x11/vboxmouse/vboxmouse.c
===================================================================
--- /trunk/src/VBox/Additions/x11/vboxmouse/vboxmouse.c	(revision 45355)
+++ /trunk/src/VBox/Additions/x11/vboxmouse/vboxmouse.c	(revision 45356)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2006-2012 Oracle Corporation
+ * Copyright (C) 2006-2013 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -117,5 +117,5 @@
 #elif GET_ABI_MAJOR(ABI_XINPUT_VERSION) >= 3
                                  VBoxPtrCtrlProc, GetMotionHistorySize(),
-								 2 /* Number of axes */
+                                 2 /* Number of axes */
 #else
 # error Unsupported version of X.Org
Index: /trunk/src/VBox/Additions/x11/vboxvideo/vboxvideo.c
===================================================================
--- /trunk/src/VBox/Additions/x11/vboxvideo/vboxvideo.c	(revision 45355)
+++ /trunk/src/VBox/Additions/x11/vboxvideo/vboxvideo.c	(revision 45356)
@@ -6,5 +6,5 @@
 
 /*
- * Copyright (C) 2006-2012 Oracle Corporation
+ * Copyright (C) 2006-2013 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -157,10 +157,10 @@
 {
     {VBOX_DEVICEID, "vbox"},
-    {-1,	 NULL}
+    {-1,            NULL}
 };
 
 static PciChipsets VBOXPCIchipsets[] = {
   { VBOX_DEVICEID, VBOX_DEVICEID, RES_SHARED_VGA },
-  { -1,		-1,		    RES_UNDEFINED },
+  { -1,            -1,            RES_UNDEFINED },
 };
 
@@ -199,5 +199,5 @@
 /* No options for now */
 static const OptionInfoRec VBOXOptions[] = {
-    { -1,		NULL,		OPTV_NONE,	{0},	FALSE }
+    { -1, NULL, OPTV_NONE, {0}, FALSE }
 };
 
@@ -391,5 +391,5 @@
     /* We always like modes specified by the user in the configuration
      * file and modes requested by the host, as doing otherwise is likely to
-	 * annoy people. */
+     * annoy people. */
     if (   !(mode->type & M_T_USERDEF)
         && !(mode->type & M_T_PREFERRED)
@@ -576,5 +576,5 @@
     0,                          /* Module minor version. Xorg-specific */
     1,                          /* Module patchlevel. Xorg-specific */
-    ABI_CLASS_VIDEODRV,	        /* This is a video driver */
+    ABI_CLASS_VIDEODRV,         /* This is a video driver */
     ABI_VIDEODRV_VERSION,
     MOD_CLASS_VIDEODRV,
@@ -1131,5 +1131,5 @@
     /* colourmap code */
     if (!miCreateDefColormap(pScreen))
-	return (FALSE);
+        return (FALSE);
 
     if(!xf86HandleColormaps(pScreen, 256, 8, vboxLoadPalette, NULL, 0))
Index: /trunk/src/VBox/Additions/x11/vboxvideo/vboxvideo.h
===================================================================
--- /trunk/src/VBox/Additions/x11/vboxvideo/vboxvideo.h	(revision 45355)
+++ /trunk/src/VBox/Additions/x11/vboxvideo/vboxvideo.h	(revision 45356)
@@ -102,7 +102,7 @@
 #include "xf86Cursor.h"
 
-#define VBOX_VERSION		4000  /* Why? */
-#define VBOX_NAME		      "VBoxVideo"
-#define VBOX_DRIVER_NAME	  "vboxvideo"
+#define VBOX_VERSION            4000  /* Why? */
+#define VBOX_NAME               "VBoxVideo"
+#define VBOX_DRIVER_NAME        "vboxvideo"
 
 #ifdef VBOX_DRI
Index: /trunk/src/VBox/Additions/x11/vboxvideo/vboxvideo_dri.c
===================================================================
--- /trunk/src/VBox/Additions/x11/vboxvideo/vboxvideo_dri.c	(revision 45355)
+++ /trunk/src/VBox/Additions/x11/vboxvideo/vboxvideo_dri.c	(revision 45356)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2012 Oracle Corporation
+ * Copyright (C) 2006-2013 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -251,5 +251,5 @@
         sprintf(pDRIInfo->busIdString, "PCI:%d:%d:%d",
             ((pciConfigPtr)pVBox->pciInfo->thisCard)->busnum,
-	        ((pciConfigPtr)pVBox->pciInfo->thisCard)->devnum,
+            ((pciConfigPtr)pVBox->pciInfo->thisCard)->devnum,
             ((pciConfigPtr)pVBox->pciInfo->thisCard)->funcnum);
 #endif
Index: /trunk/src/VBox/Devices/Network/DevINIP.cpp
===================================================================
--- /trunk/src/VBox/Devices/Network/DevINIP.cpp	(revision 45355)
+++ /trunk/src/VBox/Devices/Network/DevINIP.cpp	(revision 45356)
@@ -339,7 +339,7 @@
         PDMDEV_SET_ERROR(pDevIns, rc,
                          N_("Configuration error: Failed to get the \"IP\" value"));
-	/* @todo: perhaps we should panic if IPv4 address isn't specify, with assumtion that 
-	 * ISCSI target specified in IPv6 form.  
-	 */
+        /* @todo: perhaps we should panic if IPv4 address isn't specify, with assumtion that 
+         * ISCSI target specified in IPv6 form.  
+         */
         return rc;
     }
@@ -445,7 +445,7 @@
         }
 #else
-    	/* We've setup flags NETIF_FLAG_ETHARP and NETIF_FLAG_ETHERNET
-    	  so this should be thread-safe. */
-    	tcpip_input(p,iface);
+        /* We've setup flags NETIF_FLAG_ETHARP and NETIF_FLAG_ETHERNET
+          so this should be thread-safe. */
+        tcpip_input(p,iface);
 #endif
     }
Index: /trunk/src/VBox/Devices/Network/SrvIntNetR0.cpp
===================================================================
--- /trunk/src/VBox/Devices/Network/SrvIntNetR0.cpp	(revision 45355)
+++ /trunk/src/VBox/Devices/Network/SrvIntNetR0.cpp	(revision 45356)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2012 Oracle Corporation
+ * Copyright (C) 2006-2013 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -4998,9 +4998,9 @@
         case kIntNetTrunkType_WhateverNone:
 #ifdef VBOX_WITH_NAT_SERVICE
-	    /* 
-	     * Well, here we don't want load anything special,
-	     * just communicate between processes via internal network. 
-	     */
-	case kIntNetTrunkType_SrvNat:
+            /* 
+             * Well, here we don't want load anything special,
+             * just communicate between processes via internal network. 
+             */
+        case kIntNetTrunkType_SrvNat:
 #endif
             return VINF_SUCCESS;
@@ -5024,6 +5024,6 @@
             break;
 #ifndef VBOX_WITH_NAT_SERVICE   
-	case kIntNetTrunkType_SrvNat:
-	    pszName = "VBoxSrvNat";
+        case kIntNetTrunkType_SrvNat:
+            pszName = "VBoxSrvNat";
             break;
 #endif
@@ -5488,8 +5488,8 @@
             if (   enmTrunkType == kIntNetTrunkType_WhateverNone
 #ifdef VBOX_WITH_NAT_SERVICE
-		|| enmTrunkType == kIntNetTrunkType_SrvNat /* @todo: what does it mean */
+                || enmTrunkType == kIntNetTrunkType_SrvNat /* @todo: what does it mean */
 #endif
                 || (   pCur->enmTrunkType == enmTrunkType
-		    && !strcmp(pCur->szTrunk, pszTrunk)))
+                    && !strcmp(pCur->szTrunk, pszTrunk)))
             {
                 rc = intnetR0CheckOpenNetworkFlags(pCur, fFlags);
@@ -5588,5 +5588,5 @@
     if (   enmTrunkType == kIntNetTrunkType_WhateverNone
 #ifdef VBOX_WITH_NAT_SERVICE
-	|| enmTrunkType == kIntNetTrunkType_SrvNat /* simialar security */
+        || enmTrunkType == kIntNetTrunkType_SrvNat /* simialar security */
 #endif
         || enmTrunkType == kIntNetTrunkType_None)
@@ -5756,5 +5756,5 @@
         case kIntNetTrunkType_WhateverNone:
 #ifdef VBOX_WITH_NAT_SERVICE
-	case kIntNetTrunkType_SrvNat:
+        case kIntNetTrunkType_SrvNat:
 #endif
             if (*pszTrunk)
Index: /trunk/src/VBox/Devices/Storage/DrvVD.cpp
===================================================================
--- /trunk/src/VBox/Devices/Storage/DrvVD.cpp	(revision 45355)
+++ /trunk/src/VBox/Devices/Storage/DrvVD.cpp	(revision 45356)
@@ -931,5 +931,5 @@
         }
 #endif
-	else
+        else
             return VERR_NET_ADDRESS_FAMILY_NOT_SUPPORTED;
         return VINF_SUCCESS;
@@ -959,5 +959,5 @@
         }
 #ifdef VBOX_WITH_NEW_LWIP
-	else if (   cbAddr == sizeof(struct sockaddr_in6)
+        else if (   cbAddr == sizeof(struct sockaddr_in6)
                  && u.Addr.sa_family == AF_INET6)
         {
Index: /trunk/src/VBox/Frontends/VBoxManage/VBoxManage.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VBoxManage/VBoxManage.cpp	(revision 45355)
+++ /trunk/src/VBox/Frontends/VBoxManage/VBoxManage.cpp	(revision 45356)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2012 Oracle Corporation
+ * Copyright (C) 2006-2013 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -517,5 +517,5 @@
             { "dhcpserver",       USAGE_DHCPSERVER,        handleDHCPServer},
 #ifdef VBOX_WITH_NAT_SERVICE
-	    { "natnetwork",       USAGE_NATNETWORK,        handleNATNetwork},
+            { "natnetwork",       USAGE_NATNETWORK,        handleNATNetwork},
 #endif
             { "extpack",          USAGE_EXTPACK,           handleExtPack},
Index: /trunk/src/VBox/Frontends/VBoxManage/VBoxManageNATNetwork.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VBoxManage/VBoxManageNATNetwork.cpp	(revision 45355)
+++ /trunk/src/VBox/Frontends/VBoxManage/VBoxManageNATNetwork.cpp	(revision 45356)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2010 Oracle Corporation
+ * Copyright (C) 2006-2013 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -204,5 +204,5 @@
             CHECK_ERROR(net, COMSETTER(Network)(Bstr(pNetworkCidr).raw()));
             if(FAILED(rc))
-	      return errorArgument("Failed to set configuration");
+              return errorArgument("Failed to set configuration");
         }
         if (dhcp >= 0)
@@ -224,8 +224,8 @@
             CHECK_ERROR(net, COMSETTER(Enabled) ((BOOL)enable));
             if(FAILED(rc))
-	      return errorArgument("Failed to set configuration");
-
-        }
-	break;
+              return errorArgument("Failed to set configuration");
+
+        }
+        break;
     }
     case OP_REMOVE:
@@ -233,20 +233,20 @@
         CHECK_ERROR(a->virtualBox, RemoveNATNetwork(net));
         if(FAILED(rc))
-	  return errorArgument("Failed to remove nat network");
-	break;
+          return errorArgument("Failed to remove nat network");
+        break;
     }
     case OP_START:
     {
-	CHECK_ERROR(net, Start(Bstr("whatever").raw()));
+        CHECK_ERROR(net, Start(Bstr("whatever").raw()));
         if(FAILED(rc))
-	  return errorArgument("Failed to start network");
-	break;
+          return errorArgument("Failed to start network");
+        break;
     }
     case OP_STOP:
     {
-	CHECK_ERROR(net, Stop());
+        CHECK_ERROR(net, Stop());
         if(FAILED(rc))
-	  return errorArgument("Failed to start network");
-	break;
+          return errorArgument("Failed to start network");
+        break;
     }
     default:;
Index: /trunk/src/VBox/Main/src-server/VirtualBoxImpl.cpp
===================================================================
--- /trunk/src/VBox/Main/src-server/VirtualBoxImpl.cpp	(revision 45355)
+++ /trunk/src/VBox/Main/src-server/VirtualBoxImpl.cpp	(revision 45356)
@@ -212,5 +212,5 @@
           allDHCPServers(lockDHCPServers),
           lockNATNetworks(LOCKCLASS_LISTOFOTHEROBJECTS),
-	  allNATNetworks(lockNATNetworks),
+          allNATNetworks(lockNATNetworks),
           mtxProgressOperations(LOCKCLASS_PROGRESSLIST),
           updateReq(UPDATEREQARG),
@@ -509,6 +509,6 @@
         }
 
-	/* net services - nat networks */
-	for (settings::NATNetworksList::const_iterator it = m->pMainConfigFile->llNATNetworks.begin();
+        /* net services - nat networks */
+        for (settings::NATNetworksList::const_iterator it = m->pMainConfigFile->llNATNetworks.begin();
              it != m->pMainConfigFile->llNATNetworks.end();
              ++it)
@@ -3181,22 +3181,22 @@
 }
 void VirtualBox::onNATNetworkSetting(IN_BSTR aNetworkName, BOOL aEnabled, 
-				     IN_BSTR aNetwork, IN_BSTR aGateway, 
-				     BOOL aAdvertiseDefaultIpv6RouteEnabled, 
-				     BOOL fNeedDhcpServer)
+                                     IN_BSTR aNetwork, IN_BSTR aGateway, 
+                                     BOOL aAdvertiseDefaultIpv6RouteEnabled, 
+                                     BOOL fNeedDhcpServer)
 {
     fireNATNetworkSettingEvent(m->pEventSource, aNetworkName, aEnabled, 
-			       aNetwork, aGateway, 
-			       aAdvertiseDefaultIpv6RouteEnabled, fNeedDhcpServer);
+                               aNetwork, aGateway,
+                               aAdvertiseDefaultIpv6RouteEnabled, fNeedDhcpServer);
 }
 
 void VirtualBox::onNATNetworkPortForward(IN_BSTR aNetworkName, BOOL create, BOOL fIpv6, 
-					 IN_BSTR aRuleName, NATProtocol_T proto, 
-					 IN_BSTR aHostIp, LONG aHostPort, 
-					 IN_BSTR aGuestIp, LONG aGuestPort)
+                                         IN_BSTR aRuleName, NATProtocol_T proto, 
+                                         IN_BSTR aHostIp, LONG aHostPort, 
+                                         IN_BSTR aGuestIp, LONG aGuestPort)
 {
     fireNATNetworkPortForwardEvent(m->pEventSource, aNetworkName, create, 
-				   fIpv6, aRuleName, proto,
-				   aHostIp, aHostPort,
-				   aGuestIp, aGuestPort);
+                                   fIpv6, aRuleName, proto,
+                                   aHostIp, aHostPort,
+                                   aGuestIp, aGuestPort);
 }
 
@@ -4279,5 +4279,5 @@
 
 #ifdef VBOX_WITH_NAT_SERVICE
-	/* Saving NAT Network configuration */
+        /* Saving NAT Network configuration */
         m->pMainConfigFile->llNATNetworks.clear();
         {
Index: /trunk/src/VBox/Runtime/VBox/log-vbox.cpp
===================================================================
--- /trunk/src/VBox/Runtime/VBox/log-vbox.cpp	(revision 45355)
+++ /trunk/src/VBox/Runtime/VBox/log-vbox.cpp	(revision 45356)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2012 Oracle Corporation
+ * Copyright (C) 2006-2013 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -375,5 +375,5 @@
         if (get_team_info(0, &info) == B_OK)
         {
-        	/* there is an info.argc, but no way to know arg boundaries */
+            /* there is an info.argc, but no way to know arg boundaries */
             RTLogLoggerEx(pLogger, 0, ~0U, "Commandline: %.64s\n", info.args);
         }
Index: /trunk/src/VBox/Runtime/common/checksum/md5.cpp
===================================================================
--- /trunk/src/VBox/Runtime/common/checksum/md5.cpp	(revision 45355)
+++ /trunk/src/VBox/Runtime/common/checksum/md5.cpp	(revision 45356)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2012 Oracle Corporation
+ * Copyright (C) 2006-2013 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -31,5 +31,5 @@
 /*
  * This code implements the MD5 message-digest algorithm.
- * The algorithm is due to Ron Rivest.	This code was
+ * The algorithm is due to Ron Rivest.  This code was
  * written by Colin Plumb in 1993, no copyright is claimed.
  * This code is in the public domain; do with it what you wish.
@@ -52,5 +52,5 @@
 #include "internal/iprt.h"
 
-#include <iprt/string.h>		 /* for memcpy() */
+#include <iprt/string.h>                 /* for memcpy() */
 #if defined(RT_BIG_ENDIAN)
 # include <iprt/asm.h>                   /* RT_LE2H_U32 uses ASMByteSwapU32. */
@@ -240,5 +240,5 @@
     ctx->bits[1] += (uint32_t)(len >> 29);
 
-    t = (t >> 3) & 0x3f;	/* Bytes already in shsInfo->data */
+    t = (t >> 3) & 0x3f;        /* Bytes already in shsInfo->data */
 
     /* Handle any leading odd-sized chunks */
Index: /trunk/src/VBox/Runtime/common/misc/getopt.cpp
===================================================================
--- /trunk/src/VBox/Runtime/common/misc/getopt.cpp	(revision 45355)
+++ /trunk/src/VBox/Runtime/common/misc/getopt.cpp	(revision 45356)
@@ -103,5 +103,5 @@
 {
     if (RT_FAILURE(RTNetStrToIPv4Addr(pszValue, pAddr)))
-	return VERR_GETOPT_INVALID_ARGUMENT_FORMAT;
+        return VERR_GETOPT_INVALID_ARGUMENT_FORMAT;
     return VINF_SUCCESS;
 }
@@ -412,14 +412,14 @@
         }
 
-	case RTGETOPT_REQ_IPV4CIDR:
-	{
-	    RTNETADDRIPV4 network;
-	    RTNETADDRIPV4 netmask;
-	    if (RT_FAILURE(RTCidrStrToIPv4(pszValue, &network, &netmask)))
-	      return VERR_GETOPT_INVALID_ARGUMENT_FORMAT;
-	    pValueUnion->CidrIPv4.IPv4Network.u = network.u;
-	    pValueUnion->CidrIPv4.IPv4Netmask.u = netmask.u;
-	    break;
-	}
+        case RTGETOPT_REQ_IPV4CIDR:
+        {
+            RTNETADDRIPV4 network;
+            RTNETADDRIPV4 netmask;
+            if (RT_FAILURE(RTCidrStrToIPv4(pszValue, &network, &netmask)))
+              return VERR_GETOPT_INVALID_ARGUMENT_FORMAT;
+            pValueUnion->CidrIPv4.IPv4Network.u = network.u;
+            pValueUnion->CidrIPv4.IPv4Netmask.u = netmask.u;
+            break;
+        }
 
         case RTGETOPT_REQ_MACADDR:
Index: /trunk/src/VBox/Runtime/r3/haiku/time-haiku.cpp
===================================================================
--- /trunk/src/VBox/Runtime/r3/haiku/time-haiku.cpp	(revision 45355)
+++ /trunk/src/VBox/Runtime/r3/haiku/time-haiku.cpp	(revision 45356)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2012 Oracle Corporation
+ * Copyright (C) 2012-2013 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -44,5 +44,5 @@
 DECLINLINE(uint64_t) rtTimeGetSystemNanoTS(void)
 {
-	return (uint64_t)system_time() * 1000;
+    return (uint64_t)system_time() * 1000;
 }
 
@@ -79,6 +79,6 @@
 {
     struct timeval tv;
-	RTTimeSpecGetTimeval(pTime, &tv);
-	set_real_time_clock(tv.tv_sec);
-	return VINF_SUCCESS;
+    RTTimeSpecGetTimeval(pTime, &tv);
+    set_real_time_clock(tv.tv_sec);
+    return VINF_SUCCESS;
 }
Index: /trunk/src/VBox/VMM/VMMR0/CPUMR0.cpp
===================================================================
--- /trunk/src/VBox/VMM/VMMR0/CPUMR0.cpp	(revision 45355)
+++ /trunk/src/VBox/VMM/VMMR0/CPUMR0.cpp	(revision 45356)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2012 Oracle Corporation
+ * Copyright (C) 2006-2013 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -254,5 +254,5 @@
         }
 
-	RTMpOnAll(cpumR0CheckCpuid, pVM, NULL);
+        RTMpOnAll(cpumR0CheckCpuid, pVM, NULL);
     }
 