Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp	(revision 45358)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp	(revision 45359)
@@ -2048,9 +2048,9 @@
 bool UIMessageCenter::cannotFindGuestAdditions() const
 {
-    return messageYesNo(mainMachineWindowShown(), MessageType_Question,
-                        tr("<p>Could not find the <b>VirtualBox Guest Additions</b> CD image.</p>"
-                           "<p>Do you wish to download this CD image from the Internet?</p>"),
-                        0 /* auto-confirm id */,
-                        tr("Download"));
+    return messageOkCancel(mainMachineWindowShown(), MessageType_Question,
+                           tr("<p>Could not find the <b>VirtualBox Guest Additions</b> CD image.</p>"
+                              "<p>Do you wish to download this CD image from the Internet?</p>"),
+                           0 /* auto-confirm id */,
+                           tr("Download"));
 }
 
@@ -2107,10 +2107,10 @@
 bool UIMessageCenter::cannotFindUserManual(const QString &strMissedLocation) const
 {
-    return messageYesNo(mainWindowShown(), MessageType_Question,
-                        tr("<p>Could not find the <b>VirtualBox User Manual</b> <nobr><b>%1</b>.</nobr></p>"
-                           "<p>Do you wish to download this file from the Internet?</p>")
-                           .arg(strMissedLocation),
-                        0 /* auto-confirm id */,
-                        tr("Download"));
+    return messageOkCancel(mainWindowShown(), MessageType_Question,
+                           tr("<p>Could not find the <b>VirtualBox User Manual</b> <nobr><b>%1</b>.</nobr></p>"
+                              "<p>Do you wish to download this file from the Internet?</p>")
+                              .arg(strMissedLocation),
+                           0 /* auto-confirm id */,
+                           tr("Download"));
 }
 
@@ -2147,11 +2147,11 @@
 bool UIMessageCenter::warAboutOutdatedExtensionPack(const QString &strExtPackName, const QString &strExtPackVersion) const
 {
-    return messageYesNo(mainWindowShown(),
-                        MessageType_Question,
-                        tr("<p>You have an old version (%1) of the <b><nobr>%2</nobr></b> installed.</p>"
-                           "<p>Do you wish to download latest one from the Internet?</p>")
-                           .arg(strExtPackVersion).arg(strExtPackName),
-                        0 /* auto-confirm id */,
-                        tr("Download"));
+    return messageOkCancel(mainWindowShown(),
+                           MessageType_Question,
+                           tr("<p>You have an old version (%1) of the <b><nobr>%2</nobr></b> installed.</p>"
+                              "<p>Do you wish to download latest one from the Internet?</p>")
+                              .arg(strExtPackVersion).arg(strExtPackName),
+                           0 /* auto-confirm id */,
+                           tr("Download"));
 }
 
@@ -2359,8 +2359,9 @@
 bool UIMessageCenter::confirmOverridingFile(const QString &strPath, QWidget *pParent /*= 0*/)
 {
-    return messageYesNo(pParent, MessageType_Question,
-                        tr("A file named <b>%1</b> already exists. "
-                           "Are you sure you want to replace it?<br /><br />"
-                           "Replacing it will overwrite its contents.").arg(strPath));
+    return messageOkCancel(pParent, MessageType_Question,
+                           tr("A file named <b>%1</b> already exists. "
+                              "Are you sure you want to replace it?<br /><br />"
+                              "Replacing it will overwrite its contents.")
+                              .arg(strPath));
 }
 
@@ -2371,9 +2372,9 @@
         return confirmOverridingFile(strPaths.at(0), pParent);
     else if (strPaths.size() > 1)
-        return messageYesNo(pParent, MessageType_Question,
-                            tr("The following files already exist:<br /><br />%1<br /><br />"
-                               "Are you sure you want to replace them? "
-                               "Replacing them will overwrite their contents.")
-                               .arg(QStringList(strPaths.toList()).join("<br />")));
+        return messageOkCancel(pParent, MessageType_Question,
+                               tr("The following files already exist:<br /><br />%1<br /><br />"
+                                  "Are you sure you want to replace them? "
+                                  "Replacing them will overwrite their contents.")
+                                  .arg(QStringList(strPaths.toList()).join("<br />")));
     else
         return true;
Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.h	(revision 45358)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.h	(revision 45359)
@@ -101,33 +101,4 @@
         return message(pParent, type, strMessage, QString(), pcszAutoConfirmId,
                        iButton1, iButton2, iButton3, strButtonText1, strButtonText2, strButtonText3);
-    }
-
-    /* API: Alert providing stuff: Wrapper to the main function,
-     * Takes button type(s) as "Yes / No": */
-    bool messageYesNo(QWidget *pParent, MessageType type,
-                      const QString &strMessage,
-                      const QString &strDetails = QString(),
-                      const char *pcszAutoConfirmId = 0,
-                      const QString &strYesButtonText = QString(),
-                      const QString &strNoButtonText = QString()) const
-    {
-        return (message(pParent, type, strMessage, strDetails, pcszAutoConfirmId,
-                        AlertButton_Yes | AlertButtonOption_Default,
-                        AlertButton_No | AlertButtonOption_Escape,
-                        0,
-                        strYesButtonText, strNoButtonText, QString()) &
-                AlertButtonMask) == AlertButton_Yes;
-    }
-
-    /* API: Alert providing stuff: Wrapper to the function above,
-     * Omits details. Takes button type(s) as "Yes / No": */
-    bool messageYesNo(QWidget *pParent, MessageType type,
-                      const QString &strMessage,
-                      const char *pcszAutoConfirmId,
-                      const QString &strYesButtonText = QString(),
-                      const QString &strNoButtonText = QString()) const
-    {
-        return messageYesNo(pParent, type, strMessage, QString(),
-                            pcszAutoConfirmId, strYesButtonText, strNoButtonText);
     }
 