Index: trunk/src/VBox/Main/include/DHCPServerRunner.h
===================================================================
--- trunk/src/VBox/Main/include/DHCPServerRunner.h	(revision 45356)
+++ trunk/src/VBox/Main/include/DHCPServerRunner.h	(revision 45367)
@@ -54,7 +54,7 @@
     int setOption(DHCPCFG opt, const char *val, bool enabled)
     {
-        if(opt == 0 || opt >= DHCPCFG_NOTOPT_MAXVAL)
+        if (opt == 0 || opt >= DHCPCFG_NOTOPT_MAXVAL)
             return VERR_INVALID_PARAMETER;
-        if(isRunning())
+        if (isRunning())
             return VERR_INVALID_STATE;
 
Index: trunk/src/VBox/Main/include/NATNetworkServiceRunner.h
===================================================================
--- trunk/src/VBox/Main/include/NATNetworkServiceRunner.h	(revision 45356)
+++ trunk/src/VBox/Main/include/NATNetworkServiceRunner.h	(revision 45367)
@@ -44,7 +44,7 @@
     int setOption(NATSCCFG opt, const char *val, bool enabled)
     {
-        if(opt == 0 || opt >= NATSCCFG_NOTOPT_MAXVAL)
+        if (opt == 0 || opt >= NATSCCFG_NOTOPT_MAXVAL)
             return VERR_INVALID_PARAMETER;
-        if(isRunning())
+        if (isRunning())
             return VERR_INVALID_STATE;
 
Index: trunk/src/VBox/Main/include/netif.h
===================================================================
--- trunk/src/VBox/Main/include/netif.h	(revision 45356)
+++ trunk/src/VBox/Main/include/netif.h	(revision 45367)
@@ -124,7 +124,7 @@
 DECLINLINE(int) prefixLength2IPv6Address(ULONG cPrefix, PRTNETADDRIPV6 aAddrPtr)
 {
-    if(cPrefix > 128)
+    if (cPrefix > 128)
         return VERR_INVALID_PARAMETER;
-    if(!aAddrPtr)
+    if (!aAddrPtr)
         return VERR_INVALID_PARAMETER;
 
Index: trunk/src/VBox/Main/include/ovfreader.h
===================================================================
--- trunk/src/VBox/Main/include/ovfreader.h	(revision 45356)
+++ trunk/src/VBox/Main/include/ovfreader.h	(revision 45367)
@@ -170,9 +170,9 @@
     OVFVersion_T getOVFVersion() const
     {
-        if(version == "0.9")
+        if (version == "0.9")
             return OVFVersion_0_9;
-        else if(version == "1.0")
+        else if (version == "1.0")
             return OVFVersion_1_0;
-        else if(version == "2.0")
+        else if (version == "2.0")
             return OVFVersion_2_0;
         else
@@ -183,9 +183,9 @@
     RTCString getStringOVFVersion() const
     {
-        if(version == "0.9")
+        if (version == "0.9")
             return "0.9";
-        else if(version == "1.0")
+        else if (version == "1.0")
             return "1.0";
-        else if(version == "2.0")
+        else if (version == "2.0")
             return "2.0";
         else
Index: trunk/src/VBox/Main/src-all/ProgressImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-all/ProgressImpl.cpp	(revision 45356)
+++ trunk/src/VBox/Main/src-all/ProgressImpl.cpp	(revision 45367)
@@ -884,5 +884,5 @@
              * have to loop as long as we reached the same operation count. */
             ULONG curOp;
-            for(;;)
+            for (;;)
             {
                 rc = pProgressAsync->COMGETTER(Operation(&curOp));
Index: trunk/src/VBox/Main/src-client/ConsoleImpl2.cpp
===================================================================
--- trunk/src/VBox/Main/src-client/ConsoleImpl2.cpp	(revision 45356)
+++ trunk/src/VBox/Main/src-client/ConsoleImpl2.cpp	(revision 45367)
@@ -472,6 +472,6 @@
     for (size_t j = 0; j < u32Size; ++j)
     {
-        if(aSataPortUsed[j] > lBaseVal &&
-           aSataPortUsed[j] <= lNextPortUsed)
+        if (   aSataPortUsed[j] >  lBaseVal
+            && aSataPortUsed[j] <= lNextPortUsed)
            lNextPortUsed = aSataPortUsed[j];
     }
@@ -1669,12 +1669,12 @@
                             LONG lPortNum = 0;
                             hrc = pMediumAtt->COMGETTER(Port)(&lPortNum);                   H();
-                            if(SUCCEEDED(hrc))
+                            if (SUCCEEDED(hrc))
                             {
                                 DeviceType_T lType;
                                 hrc = pMediumAtt->COMGETTER(Type)(&lType);                    H();
-                                if(SUCCEEDED(hrc) && lType == DeviceType_HardDisk)
+                                if (SUCCEEDED(hrc) && lType == DeviceType_HardDisk)
                                 {
                                     /* find min port number used for HD */
-                                    if(lPortNum < lPortLUN[0])
+                                    if (lPortNum < lPortLUN[0])
                                         lPortLUN[0] = lPortNum;
                                     lPortUsed[u32HDSataPortCount++] = lPortNum;
Index: trunk/src/VBox/Main/src-client/GuestCtrlPrivate.cpp
===================================================================
--- trunk/src/VBox/Main/src-client/GuestCtrlPrivate.cpp	(revision 45356)
+++ trunk/src/VBox/Main/src-client/GuestCtrlPrivate.cpp	(revision 45367)
@@ -656,5 +656,5 @@
     int rc = VINF_SUCCESS;
     size_t p = 0;
-    while(p < listPair.size() && RT_SUCCESS(rc))
+    while (p < listPair.size() && RT_SUCCESS(rc))
     {
         Utf8Str strKey = listPair.at(p++);
Index: trunk/src/VBox/Main/src-client/GuestDnDImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-client/GuestDnDImpl.cpp	(revision 45356)
+++ trunk/src/VBox/Main/src-client/GuestDnDImpl.cpp	(revision 45367)
@@ -441,5 +441,5 @@
     RTCList<RTCString> list = strFormats.split("\r\n");
     size_t i = 0;
-    while(i < list.size())
+    while (i < list.size())
     {
         /* Only keep allowed format types. */
Index: trunk/src/VBox/Main/src-server/ApplianceImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/ApplianceImpl.cpp	(revision 45356)
+++ trunk/src/VBox/Main/src-server/ApplianceImpl.cpp	(revision 45367)
@@ -274,10 +274,10 @@
 }
 
-bool checkComplianceDigestAndOVFVersion(bool digestType, ovf::OVFVersion_T ovfVersion)
+bool checkComplianceDigestAndOVFVersion(bool fDigestType, ovf::OVFVersion_T ovfVersion)
 {
     bool res = false;
-    if ((ovfVersion == ovf::OVFVersion_2_0 && digestType == true) ||
-        (ovfVersion == ovf::OVFVersion_1_0 && digestType == false) ||
-        (ovfVersion == ovf::OVFVersion_0_9 && digestType == false))
+    if (   (ovfVersion == ovf::OVFVersion_2_0 &&  fDigestType)
+        || (ovfVersion == ovf::OVFVersion_1_0 && !fDigestType)
+        || (ovfVersion == ovf::OVFVersion_0_9 && !fDigestType))
         res = true;
     return res;
@@ -794,5 +794,5 @@
            we have to loop as long as we reached the same operation count. */
         ULONG curOp;
-        for(;;)
+        for (;;)
         {
             rc = pProgressAsync->COMGETTER(Operation(&curOp));
Index: trunk/src/VBox/Main/src-server/ApplianceImplExport.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/ApplianceImplExport.cpp	(revision 45356)
+++ trunk/src/VBox/Main/src-server/ApplianceImplExport.cpp	(revision 45367)
@@ -1677,5 +1677,5 @@
         }
         rc = writeFSImpl(pTask, writeLock, pShaIo, &storage);
-    }while(0);
+    } while (0);
 
     /* Cleanup */
@@ -1731,5 +1731,5 @@
         }
         rc = writeFSImpl(pTask, writeLock, pShaIo, &storage);
-    }while(0);
+    } while (0);
 
     RTTarClose(tar);
@@ -1742,5 +1742,5 @@
 
     /* Delete ova file on error */
-    if(FAILED(rc))
+    if (FAILED(rc))
         RTFileDelete(pTask->locInfo.strPath.c_str());
 
Index: trunk/src/VBox/Main/src-server/ApplianceImplIO.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/ApplianceImplIO.cpp	(revision 45356)
+++ trunk/src/VBox/Main/src-server/ApplianceImplIO.cpp	(revision 45367)
@@ -108,5 +108,5 @@
 # define DEBUG_PRINT_FLOW() RTPrintf("%s\n", __FUNCTION__)
 #else
-# define DEBUG_PRINT_FLOW() do {} while(0)
+# define DEBUG_PRINT_FLOW() do {} while (0)
 #endif
 
@@ -478,5 +478,5 @@
     int rc = VINF_SUCCESS;
     bool fLoop = true;
-    while(fLoop)
+    while (fLoop)
     {
         /* What should we do next? */
@@ -756,5 +756,5 @@
         }
     }
-    while(0);
+    while (0);
 
     if (RT_FAILURE(rc))
@@ -1015,5 +1015,5 @@
         {
             rc = shaSignalManifestThread(pInt, STATUS_WRITE);
-            if(RT_FAILURE(rc))
+            if (RT_FAILURE(rc))
                 break;
             /* If there is _no_ free space available, we have to wait until it is. */
@@ -1102,5 +1102,5 @@
         {
             rc = shaSignalManifestThread(pInt, STATUS_READ);
-            if(RT_FAILURE(rc))
+            if (RT_FAILURE(rc))
                 break;
             /* If there is _no_ data available, we have to wait until it is. */
@@ -1275,5 +1275,5 @@
             cbAllRead += cbRead;
         }
-    }while(0);
+    } while (0);
 
     pIfIo->pfnClose(pvUser, pvStorage);
Index: trunk/src/VBox/Main/src-server/ApplianceImplImport.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/ApplianceImplImport.cpp	(revision 45356)
+++ trunk/src/VBox/Main/src-server/ApplianceImplImport.cpp	(revision 45367)
@@ -852,5 +852,5 @@
                 RTFILE pFile = NULL;
                 vrc = RTFileOpen(&pFile, strMfFile.c_str(), RTFILE_O_OPEN | RTFILE_O_READ | RTFILE_O_DENY_NONE);
-                if(RT_SUCCESS(vrc) && pFile != NULL)
+                if (RT_SUCCESS(vrc) && pFile != NULL)
                 {
                     uint64_t cbFile = 0;
@@ -932,5 +932,5 @@
         }
 
-    }while(0);
+    }while (0);
 
     /* Cleanup */
@@ -1068,5 +1068,5 @@
                     break;
 
-            }while(0);
+            } while (0);
 
             RTTarClose(tar);
Index: trunk/src/VBox/Main/src-server/HostImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/HostImpl.cpp	(revision 45356)
+++ trunk/src/VBox/Main/src-server/HostImpl.cpp	(revision 45367)
@@ -549,5 +549,5 @@
     int rc = VERR_GENERAL_FAILURE;
 
-    hr = pncc->GetDisplayName( &lpszName );
+    hr = pncc->GetDisplayName(&lpszName);
     Assert(hr == S_OK);
     if (hr == S_OK)
@@ -642,8 +642,8 @@
 
     /* we are using the INetCfg API for getting the list of miniports */
-    hr = VBoxNetCfgWinQueryINetCfg( FALSE,
-                       VBOX_APP_NAME,
-                       &pNc,
-                       &lpszApp );
+    hr = VBoxNetCfgWinQueryINetCfg(FALSE,
+                                   VBOX_APP_NAME,
+                                   &pNc,
+                                   &lpszApp);
     Assert(hr == S_OK);
     if (hr == S_OK)
@@ -668,9 +668,9 @@
             hr = VBoxNetCfgWinGetBindingPathEnum(pTcpIpNcc, EBP_BELOW, &pEnumBp);
             Assert(hr == S_OK);
-            if ( hr == S_OK )
+            if (hr == S_OK)
             {
                 hr = VBoxNetCfgWinGetFirstBindingPath(pEnumBp, &pBp);
                 Assert(hr == S_OK || hr == S_FALSE);
-                while( hr == S_OK )
+                while (hr == S_OK)
                 {
                     /* S_OK == enabled, S_FALSE == disabled */
@@ -679,11 +679,11 @@
                         hr = VBoxNetCfgWinGetBindingInterfaceEnum(pBp, &pEnumBi);
                         Assert(hr == S_OK);
-                        if ( hr == S_OK )
+                        if (hr == S_OK)
                         {
                             hr = VBoxNetCfgWinGetFirstBindingInterface(pEnumBi, &pBi);
                             Assert(hr == S_OK);
-                            while(hr == S_OK)
+                            while (hr == S_OK)
                             {
-                                hr = pBi->GetLowerComponent( &pMpNcc );
+                                hr = pBi->GetLowerComponent(&pMpNcc);
                                 Assert(hr == S_OK);
                                 if (hr == S_OK)
@@ -699,5 +699,5 @@
                                         }
                                     }
-                                    VBoxNetCfgWinReleaseRef( pMpNcc );
+                                    VBoxNetCfgWinReleaseRef(pMpNcc);
                                 }
                                 VBoxNetCfgWinReleaseRef(pBi);
Index: trunk/src/VBox/Main/src-server/SnapshotImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/SnapshotImpl.cpp	(revision 45356)
+++ trunk/src/VBox/Main/src-server/SnapshotImpl.cpp	(revision 45367)
@@ -2524,6 +2524,6 @@
 
                 {
-                    if ( pSource_local.isNull() ||
-                         pSource_local == pTarget_local )
+                    if (   pSource_local.isNull()
+                        || pSource_local == pTarget_local)
                     {
                         ++it_md;
Index: trunk/src/VBox/Main/src-server/USBControllerImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/USBControllerImpl.cpp	(revision 45356)
+++ trunk/src/VBox/Main/src-server/USBControllerImpl.cpp	(revision 45367)
@@ -437,5 +437,5 @@
 
     AutoCaller autoCaller(this);
-    if(FAILED(autoCaller.rc())) return autoCaller.rc();
+    if (FAILED(autoCaller.rc())) return autoCaller.rc();
 
     AutoReadLock alock(this COMMA_LOCKVAL_SRC_POS);
Index: trunk/src/VBox/Main/src-server/generic/NetIf-generic.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/generic/NetIf-generic.cpp	(revision 45356)
+++ trunk/src/VBox/Main/src-server/generic/NetIf-generic.cpp	(revision 45367)
@@ -316,5 +316,5 @@
     int rc = VINF_SUCCESS;
     HRESULT hr = pVBox->COMGETTER(Host)(host.asOutParam());
-    if(SUCCEEDED(hr))
+    if (SUCCEEDED(hr))
     {
         Bstr ifname;
@@ -329,5 +329,5 @@
                             Bstr("Removing host network interface").raw(),
                             FALSE /* aCancelable */);
-        if(SUCCEEDED(rc))
+        if (SUCCEEDED(rc))
         {
             progress.queryInterfaceTo(aProgress);
Index: trunk/src/VBox/Main/src-server/linux/HostHardwareLinux.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/linux/HostHardwareLinux.cpp	(revision 45356)
+++ trunk/src/VBox/Main/src-server/linux/HostHardwareLinux.cpp	(revision 45367)
@@ -1283,5 +1283,5 @@
         if (RT_FAILURE(rc = pipeCreateSimple(&mhWakeupPipeR, &mhWakeupPipeW)))
             break;
-    } while(0);
+    } while (0);
     mStatus = rc;
     if (RT_FAILURE(rc))
Index: trunk/src/VBox/Main/src-server/linux/USBGetDevices.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/linux/USBGetDevices.cpp	(revision 45356)
+++ trunk/src/VBox/Main/src-server/linux/USBGetDevices.cpp	(revision 45367)
@@ -1431,5 +1431,5 @@
 }
 # define dlsym testDLSym
-# define close(a) do {} while(0)
+# define close(a) do {} while (0)
 #endif
 
Index: trunk/src/VBox/Main/src-server/solaris/USBProxyServiceSolaris.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/solaris/USBProxyServiceSolaris.cpp	(revision 45356)
+++ trunk/src/VBox/Main/src-server/solaris/USBProxyServiceSolaris.cpp	(revision 45367)
@@ -305,5 +305,5 @@
 
             rc = DI_WALK_CONTINUE;
-        } while(0);
+        } while (0);
 
         di_devfs_path_free(pszDevicePath);
Index: trunk/src/VBox/Main/src-server/win/NetIf-win.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/win/NetIf-win.cpp	(revision 45356)
+++ trunk/src/VBox/Main/src-server/win/NetIf-win.cpp	(revision 45367)
@@ -1513,5 +1513,5 @@
                                 hr = pBp->EnumBindingInterfaces(&pEnumBi);
                                 Assert(hr == S_OK);
-                                if ( hr == S_OK )
+                                if (hr == S_OK)
                                 {
                                     hr = pEnumBi->Reset();
@@ -1521,5 +1521,5 @@
                                         while ((hr = pEnumBi->Next(1, &pBi, NULL)) == S_OK)
                                         {
-                                            hr = pBi->GetLowerComponent( &pMpNcc );
+                                            hr = pBi->GetLowerComponent(&pMpNcc);
                                             Assert(hr == S_OK);
                                             if (hr == S_OK)
Index: trunk/src/VBox/Main/testcase/tstCollector.cpp
===================================================================
--- trunk/src/VBox/Main/testcase/tstCollector.cpp	(revision 45356)
+++ trunk/src/VBox/Main/testcase/tstCollector.cpp	(revision 45367)
@@ -64,5 +64,5 @@
             break; \
         ++nCalls; \
-    } while(RTTimeMilliTS() - start < RUN_TIME_MS); \
+    } while (RTTimeMilliTS() - start < RUN_TIME_MS); \
     if (RT_FAILURE(rc)) \
     { \
@@ -469,5 +469,5 @@
         }
         start = RTTimeMilliTS();
-        while(RTTimeMilliTS() - start < 5000)
+        while (RTTimeMilliTS() - start < 5000)
             ; // Loop for 5 seconds
         rc = collector->preCollect(hints, 0);
Index: trunk/src/VBox/Main/webservice/vboxweb.cpp
===================================================================
--- trunk/src/VBox/Main/webservice/vboxweb.cpp	(revision 45356)
+++ trunk/src/VBox/Main/webservice/vboxweb.cpp	(revision 45367)
@@ -1444,5 +1444,5 @@
     ssize_t cbOut = RTBase64DecodedSize(pszStr, NULL);
 
-    if(cbOut > DECODE_STR_MAX)
+    if (cbOut > DECODE_STR_MAX)
     {
         WebLog("Decode string too long.\n");